diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_user.c ircd-hybrid-6.0/src/s_user.c
--- ircd-hybrid-6.0.orig/src/s_user.c	Fri Jun  8 18:03:40 2001
+++ ircd-hybrid-6.0/src/s_user.c	Fri Jun  8 16:25:06 2001
@@ -2201,201 +2101,162 @@
       return 0;
     }
 
-  /* find flags already set for user */
-  setflags = acptr->umodes;
-  
+  CopyUmodes(old_umodes, acptr->umodes);
+
   /*
    * parse mode change string(s)
    */
   for (p = &parv[2]; p && *p; p++ )
     for (m = *p; *m; m++)
-      switch(*m)
-        {
-        case '+' :
-          what = MODE_ADD;
-          break;
-        case '-' :
-          what = MODE_DEL;
-          break;        
-
-        case 'O': case 'o' :
-          if(what == MODE_ADD)
-            {
-              if((IsServer(cptr) || ircophack) && !IsOper(acptr))
-                {
-                  ++Count.oper;
-                  SetOper(acptr);
-
-                  if (ircophack && MyClient(acptr))
-                    {
-                      sendto_ops_flags_butone(sptr, FLAGS_SERVNOTICE,
-                        "%s just made %s (%s@%s) an operator",
-                        sptr->name, acptr->name,
-                        acptr->username, acptr->host);
-
-                      acptr->next_oper_client = oper_cptr_list;
-                      oper_cptr_list = acptr;
-
-                      sendto_one(acptr, form_str(RPL_YOUREOPER), me.name,
-                                 acptr->name);
-
-                      SendMessageFile(acptr, &ConfigFileEntry.opermotd);
-                    }
-                }
-            }
-          else
-            {
-	      /* Only decrement the oper counts if an oper to begin with
-               * found by Pat Szuta, Perly , perly@xnet.com 
-               */
-
-              if(!IsAnOper(acptr))
-                break;
-
-              acptr->umodes &= ~(FLAGS_OPER|FLAGS_LOCOP);
-
-              Count.oper--;
-
-#ifdef USE_USER_UMODES 
-	      acptr->umodes &= USER_UMODES | ~ALL_UMODES;
-#endif
-              if (MyConnect(acptr))
-                {
-                  aClient *prev_cptr = (aClient *)NULL;
-                  aClient *cur_cptr = oper_cptr_list;
-
-                  fdlist_delete(acptr->fd, FDL_OPER | FDL_BUSY);
-                  if (acptr->confs->value.aconf->status &
-                      (CONF_OPERATOR|CONF_LOCOP))
-                    detach_conf(acptr,acptr->confs->value.aconf);
-                  acptr->flags2 &= ~(FLAGS2_OPER_GLOBAL_KILL|
-                                    FLAGS2_OPER_REMOTE|
-                                    FLAGS2_OPER_UNKLINE|
-                                    FLAGS2_OPER_GLINE|
-                                    FLAGS2_OPER_N|
-#ifdef GODOPERS
-  			            FLAGS2_OPER_GOD|
-#endif
-                                    FLAGS2_OPER_K|
-                                    FLAGS2_OPER_IMMUNE|
-                                    FLAGS2_OPER_AUSPEX);
-                  while(cur_cptr)
-                    {
-                      if(acptr == cur_cptr) 
-                        {
-                          if(prev_cptr)
-                            prev_cptr->next_oper_client = cur_cptr->next_oper_client;
-                          else
-                            oper_cptr_list = cur_cptr->next_oper_client;
-                          cur_cptr->next_oper_client = (aClient *)NULL;
-                          break;
-                        }
-                      else
-                        prev_cptr = cur_cptr;
-                      cur_cptr = cur_cptr->next_oper_client;
-                    }
-                }
-            }
-          break;
-	case 'e' :
-          if(!IsServer(cptr))
-            break;
-
-          SetIdentifiedNick(sptr);
-          break;
-
-          /* we may not get these,
-           * but they shouldnt be in default
-           */
-        case ' ' :
-        case '\n' :
-        case '\r' :
-        case '\t' :
-          break;
-        default :
-          if( (flag = user_modes_from_c_to_bitmask[(unsigned char)*m]))
-            {
-              if (what == MODE_ADD)
-                acptr->umodes |= flag;
-              else
-                acptr->umodes &= ~flag;  
-            }
-          else
-            {
-              if ( MyConnect(sptr))
-                badflag = YES;
-            }
-          break;
-        }
+      {
+	switch(*m)
+	  {
+	  case '+' :
+	    what = MODE_ADD;
+	    break;
+	  case '-' :
+	    what = MODE_DEL;
+	    break;        
+
+	  case 'O': case 'o' :
+	    if(what == MODE_ADD)
+	      {
+		/* I'm going to disable this for now, we do things differently
+		 *  --asuffield
+		 */
+		break;
+
+		if((IsServer(cptr) || ircophack) && !IsOper(acptr))
+		  {
+		    ++Count.oper;
+		    SetOper(acptr);
+		    SetBit(acptr->allowed_umodes, UMODE_OPER);
+
+		    if (ircophack && MyClient(acptr))
+		      {
+			sendto_ops_flag_butone(sptr, UMODE_SERVNOTICE,
+					       "%s just made %s (%s@%s) an operator",
+					       sptr->name, acptr->name,
+					       acptr->username, acptr->host);
+
+			acptr->next_oper_client = oper_cptr_list;
+			oper_cptr_list = acptr;
+
+			sendto_one(acptr, form_str(RPL_YOUREOPER), me.name,
+				   acptr->name);
+
+			SendMessageFile(acptr, &ConfigFileEntry.opermotd);
+		      }
+		  }
+	      }
+	    else
+	      {
+		/* Only decrement the oper counts if an oper to begin with
+		 * found by Pat Szuta, Perly , perly@xnet.com 
+		 */
+
+		if(!IsAnOper(acptr))
+		  break;
+
+		ClearBit(acptr->umodes, UMODE_OPER);
+		ClearBit(acptr->umodes, UMODE_LOCOP);
+
+		Count.oper--;
+
+		CopyUmodes(acptr->allowed_umodes, user_umodes);
+		AndUmodes(acptr->umodes, acptr->umodes, acptr->allowed_umodes);
+
+		if (MyConnect(acptr))
+		  {
+		    aClient *prev_cptr = (aClient *)NULL;
+		    aClient *cur_cptr = oper_cptr_list;
+
+		    fdlist_delete(acptr->fd, FDL_OPER | FDL_BUSY);
+		    if (acptr->confs->value.aconf->status &
+			(CONF_OPERATOR|CONF_LOCOP))
+		      detach_conf(acptr,acptr->confs->value.aconf);
+		    while(cur_cptr)
+		      {
+			if(acptr == cur_cptr) 
+			  {
+			    if(prev_cptr)
+			      prev_cptr->next_oper_client = cur_cptr->next_oper_client;
+			    else
+			      oper_cptr_list = cur_cptr->next_oper_client;
+			    cur_cptr->next_oper_client = (aClient *)NULL;
+			    break;
+			  }
+			else
+			  prev_cptr = cur_cptr;
+			cur_cptr = cur_cptr->next_oper_client;
+		      }
+		  }
+	      }
+	    break;
+	    /* This needs no magic. -- asuffield
+	      case 'e' :
+	      if(!IsServer(cptr))
+	      break;
+	      
+	      SetIdentifiedNick(sptr);
+	      break; */
+
+	    /* we may not get these,
+	     * but they shouldnt be in default
+	     */
+	  case ' ' :
+	  case '\n' :
+	  case '\r' :
+	  case '\t' :
+	    break;
+	  default :
+	    if((flag = user_modes_from_c_to_bitmask[(unsigned char)*m]))
+	      {
+		if ((flag == UMODE_OPER) || (flag == UMODE_LOCOP))
+		  break;
+		if (what == MODE_ADD)
+		  SetBit(acptr->umodes, flag);
+		else
+		  ClearBit(acptr->umodes, flag);
+	      }
+	    else
+	      {
+		if (MyConnect(sptr))
+		  badflag = YES;
+	      }
+	    break;
+	  }
+      }
 
-#ifdef USE_USER_UMODES
-  /* Use ALL_UMODES to make sure we don't mess with special server flags. 
-   * And (acptr->umodes ~setflags) to prevent umodes set by an oper from
-   * being removed */
-  if (((acptr->umodes & ~setflags) & ALL_UMODES & ~USER_UMODES) && !IsAnOper(sptr))
-    {
-      acptr->umodes &= USER_UMODES | ~ALL_UMODES;
-      badflag = YES;
+  /* Find which ones shouldn't have been set, and unset them (and warn) */
+  AndNotUmodes(bad_umodes, acptr->umodes, acptr->allowed_umodes);
+  if (AnyBits(bad_umodes))
+    {
+      AndUmodes(acptr->umodes, acptr->umodes, acptr->allowed_umodes);
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr, ":%s NOTICE %s :*** The privilege(s) +%s is not granted", me.name, parv[0],
+		   oper_flags_as_string(bad_umodes));
+      else
+	badflag = YES;
     }
-#endif
 
   if(badflag)
-    sendto_one(sptr, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
-
-#ifdef CHANNEL_CREATION_NOTICE
-  if (acptr->umodes & FLAGS_CHCREATE && !IsSetOperChanCreate(sptr))
-    {
-      sendto_one(sptr,":%s NOTICE %s :*** You need oper and L flag for +l",
-                     me.name,parv[0]);
-      acptr->umodes &= ~FLAGS_CHCREATE;
-    }
-#endif /* CHANNEL_CREATION_NOTICE */
-
-  if ((acptr->umodes & FLAGS_NCHANGE) && !IsSetOperN(sptr))
     {
-      sendto_one(sptr,":%s NOTICE %s :*** You need oper and N flag for +n",
-                 me.name,parv[0]);
-      acptr->umodes &= ~FLAGS_NCHANGE; /* only tcm's really need this */
+      sendto_one(sptr, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
     }
 
-
-  if ((acptr->umodes & FLAGS_IMMUNE) && !IsSetOperM(sptr) && MyClient(sptr) && !IsServer(cptr))
-    {
-      sendto_one(sptr,":%s NOTICE %s :*** You need oper and M flag for +m",
-                 me.name,parv[0]);
-      acptr->umodes &= ~FLAGS_IMMUNE; /* only services really need this,
-                                        though it could be useful for
-                                        opers once in a while */
-    }
-
-  if ((acptr->umodes & FLAGS_AUSPEX) && !IsSetOperAuspex(sptr) && MyClient(sptr) && !IsServer(sptr))
-    {
-      sendto_one(sptr,":%s NOTICE %s :*** You need oper and A flag for +a",
-		 me.name,parv[0]);
-      acptr->umodes &= ~FLAGS_AUSPEX;
-    }
-
-#ifdef GODOPERS
-  if ((acptr->umodes & FLAGS_GOD) && !IsSetOperGod(sptr) && MyClient(sptr) && !IsServer(sptr))
-    {
-      sendto_one(sptr,":%s NOTICE %s :*** You need oper and P flag for +p",
-		 me.name,parv[0]);
-      acptr->umodes &= ~FLAGS_GOD;
-    }
-#endif
-
-  if (!(setflags & FLAGS_INVISIBLE) && IsInvisible(acptr))
+  if (!TestBit(old_umodes, UMODE_INVISIBLE) && IsInvisible(acptr))
     ++Count.invisi;
-  if ((setflags & FLAGS_INVISIBLE) && !IsInvisible(acptr))
+  if (TestBit(old_umodes, UMODE_INVISIBLE) && !IsInvisible(acptr))
     --Count.invisi;
   /*
    * compare new flags with old flags and send string which
    * will cause servers to update correctly.
    */
   if(ircophack)
-    send_umode_out_oper(cptr, sptr, setflags, acptr);
+    send_umode_out_oper(cptr, sptr, old_umodes, acptr);
   else
-    send_umode_out(cptr, sptr, setflags);
+    send_umode_out(cptr, sptr, old_umodes);
 
   return 0;
 }
@@ -2405,7 +2266,7 @@
  * send the MODE string for user (user) to connection cptr
  * -avalon
  */
-void send_umode(aClient *cptr, aClient *sptr, int old, int sendmask,
+void send_umode(aClient *cptr, aClient *sptr, umode_t old, umode_t sendmask,
                 char *umode_buf)
 {
   int   i;
@@ -2423,10 +2284,10 @@
   for (i = 0; user_modes[i].letter; i++ )
     {
       flag = user_modes[i].mode;
-
-      if (MyClient(sptr) && !(flag & sendmask))
+      
+      if (MyClient(sptr) && !TestBit(sendmask,flag))
         continue;
-      if ((flag & old) && !(sptr->umodes & flag))
+      if (old && TestBit(old,flag) && !TestBit(sptr->umodes,flag))
         {
           if (what == MODE_DEL)
             *m++ = user_modes[i].letter;
@@ -2437,7 +2298,7 @@
               *m++ = user_modes[i].letter;
             }
         }
-      else if (!(flag & old) && (sptr->umodes & flag))
+      else if ((!old || !TestBit(old,flag)) && TestBit(sptr->umodes,flag))
         {
           if (what == MODE_ADD)
             *m++ = user_modes[i].letter;
@@ -2465,25 +2326,25 @@
  * server -Dianora
  */
 void send_umode_out(aClient *cptr,
-                       aClient *sptr,
-                       int old)
+		    aClient *sptr,
+                    umode_t old)
 {
   aClient *acptr;
   char buf[BUFSIZE];
 
-  send_umode(NULL, sptr, old, SEND_UMODES, buf);
+  send_umode(NULL, sptr, old, send_umodes, buf);
 
   for(acptr = serv_cptr_list; acptr; acptr = acptr->next_server_client)
     {
       if((acptr != cptr) && (acptr != sptr) && (*buf))
         {
           sendto_one(acptr, ":%s MODE %s :%s",
-                   sptr->name, sptr->name, buf);
+		     sptr->name, sptr->name, buf);
         }
     }
 
   if (cptr && MyClient(cptr))
-    send_umode(cptr, sptr, old, ALL_UMODES, buf);
+    send_umode(cptr, sptr, old, all_umodes, buf);
 }
 
 /*
@@ -2491,13 +2352,13 @@
  */
 void send_umode_out_oper(aClient *cptr,
                          aClient *ircop,
-                         int old,
+                         umode_t old,
                          aClient *sptr)
 {
   aClient *acptr;
   char buf[BUFSIZE];
 
-  send_umode(NULL, sptr, old, ALL_UMODES, buf);
+  send_umode(NULL, sptr, old, all_umodes, buf);
 
   if (*buf)
     for(acptr = serv_cptr_list; acptr; acptr = acptr->next_server_client)
@@ -2509,7 +2370,7 @@
           }
       }
 
-  send_umode(NULL, sptr, old, ALL_UMODES, buf);
+  send_umode(NULL, sptr, old, all_umodes, buf);
 
   if (MyClient(sptr) && *buf)
     sendto_one(sptr, ":%s MODE %s :%s",
@@ -2588,4 +2449,56 @@
     sptr->user->silence = lp;
 
     return 0;
+}
+
+void init_umodes()
+{
+  int i, field, bit;
+  /* Fill out the reverse umode map */
+  for (i = 0; user_modes[i].letter; i++)
+    user_modes_from_c_to_bitmask[(unsigned char)user_modes[i].letter] = user_modes[i].mode;
+  /* Fill out the bitfield map */
+  bit = 1;
+  field = 0;
+  for (i = 0; i < BITFIELD_SIZE; i++)
+    {
+      bitfield_lookup[i].bit = bit;
+      bitfield_lookup[i].field = field;
+      if (bit == 0x80000000)
+	{
+	  field++;
+	  bit = 1;
+	}
+      else
+	bit = bit << 1;
+    }
+
+  /* Here we fill in send_umodes and user_umodes */
+  ClearBitfield(send_umodes);
+  ClearBitfield(user_umodes);
+  ClearBitfield(all_umodes);
+  NotUmodes(all_umodes, all_umodes);
+
+/* These are the umodes which are propogated. Note that most oper umodes are
+ * checked at the source, so don't need to be propogated
+ *  -- asuffield
+ */
+  SetBit(send_umodes, UMODE_INVISIBLE);
+  SetBit(send_umodes, UMODE_OPER);
+  SetBit(send_umodes, UMODE_WALLOP);
+  SetBit(send_umodes, UMODE_IMMUNE);
+  SetBit(send_umodes, UMODE_IDENTIFIED);
+  SetBit(send_umodes, UMODE_NINVITE);
+  SetBit(send_umodes, UMODE_BLOCK_NOTID);
+  SetBit(send_umodes, UMODE_NCTCP);
+
+/*
+ * Only opers can have modes outside USER_UMODES.  If you change this
+ * set, then also change the explanatory NOTICE in user_mode(). -dark
+ */
+  SetBit(user_umodes, UMODE_INVISIBLE);
+  SetBit(user_umodes, UMODE_WALLOP);
+  SetBit(user_umodes, UMODE_NINVITE);
+  SetBit(user_umodes, UMODE_BLOCK_NOTID);
+  SetBit(user_umodes, UMODE_NCTCP);
 }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/send.c ircd-hybrid-6.0/src/send.c
--- ircd-hybrid-6.0.orig/src/send.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/send.c	Fri Jun  8 15:46:10 2001
@@ -965,7 +965,7 @@
  */
 
 void
-sendto_ops_flags(int flags, const char *pattern, ...)
+sendto_ops_flag(int flag, const char *pattern, ...)
 
 {
   va_list args;
@@ -974,11 +974,11 @@
 
   va_start(args, pattern);
 
-  if((flags & FLAGS_SKILL) || (flags & FLAGS_SERVNOTICE))
+  if((flag == UMODE_SKILL) || (flag == UMODE_SERVNOTICE))
     {
       for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client)
         {
-          if(cptr->umodes & flags)
+          if(TestBit(cptr->umodes,flag))
             {
               (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
                                me.name, cptr->name);
@@ -989,15 +989,11 @@
             }
         } /* for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client) */
     }
-
-  flags &= ~FLAGS_SKILL;
-  flags &= ~FLAGS_SERVNOTICE;
-
-  if(flags)
+  else
     {
       for(cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client)
         {
-          if(cptr->umodes & flags)
+          if(TestBit(cptr->umodes,flag))
             {
               (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
                                me.name, cptr->name);
@@ -1111,15 +1107,7 @@
     {
       if (!SendWallops(cptr))
         continue;
-#if 0      
-      if (!(IsServer(from) || IsMe(from)) &&
-          MyClient(cptr) && !IsOper(cptr))
-        continue;
 
-      if (MyClient(cptr) && !IsAnOper(cptr) &&
-          !(IsServer(from) || IsMe(from)))
-        continue;
-#endif
       /* find connection oper is on */
       index = cptr->from->fd;
 
@@ -1173,7 +1161,7 @@
 
   for (acptr = oper_cptr_list; acptr; acptr = acptr->next_oper_client)
     {
-      if (!SendOperwall(acptr))
+      if (!ReceiveOperwall(acptr))
         continue; /* has to be oper if in this linklist */
 
       sendto_one(acptr, ":%s WALLOPS :%s - %s", sender, type_message, message);
@@ -1362,7 +1350,7 @@
  */
 
 void
-sendto_realops_flags(int flags, const char *pattern, ...)
+sendto_realops_flag(int flag, const char *pattern, ...)
 
 {
   va_list args;
@@ -1373,7 +1361,7 @@
 
   for (cptr = oper_cptr_list; cptr; cptr = cptr->next_oper_client)
     {
-      if(cptr->umodes & flags)
+      if(TestBit(cptr->umodes,flag))
         {
           (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
                            me.name, cptr->name);
@@ -1506,7 +1494,7 @@
  */
 
 void
-sendto_ops_flags_butone(aClient *one, int flags, const char *pattern, ...)
+sendto_ops_flag_butone(aClient *one, int flag, const char *pattern, ...)
 
 {
   va_list args;
@@ -1515,28 +1503,25 @@
 
   va_start(args, pattern);
 
-  if(flags)
+  for(cptr = local_cptr_list; cptr; cptr = cptr->next)
     {
-      for(cptr = local_cptr_list; cptr; cptr = cptr->next)
-        {
-          if (IsPerson(cptr) && (cptr->umodes & flags))
-            {
-              (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
-                               me.name, cptr->name);
-              (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
-              vsendto_one(cptr, nbuf, args);
-            }
-        }
-      (void)ircsprintf(nbuf, ":%s WALLOPS %i :",
-                       me.name, flags);
-      (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
-      for(cptr = serv_cptr_list; cptr; cptr = cptr->next_server_client)
-        {
-          if (IsMe(cptr) || (one && (cptr == one->from)))
-            continue;
-          vsendto_one(cptr, nbuf, args);
-        }
+      if (IsPerson(cptr) && TestBit(cptr->umodes,flag))
+	{
+	  (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
+			   me.name, cptr->name);
+	  (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+	  vsendto_one(cptr, nbuf, args);
+	}
+    }
+  (void)ircsprintf(nbuf, ":%s WALLOPS %i :",
+		   me.name, flag);
+  (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+  for(cptr = serv_cptr_list; cptr; cptr = cptr->next_server_client)
+    {
+      if (IsMe(cptr) || (one && (cptr == one->from)))
+	continue;
+      vsendto_one(cptr, nbuf, args);
     }
   va_end(args);
-}  /* sendto_ops_flags */
+}
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/whowas.c ircd-hybrid-6.0/src/whowas.c
--- ircd-hybrid-6.0.orig/src/whowas.c	Tue Nov 21 06:49:33 2000
+++ ircd-hybrid-6.0/src/whowas.c	Wed Jun  6 11:23:52 2001
@@ -188,7 +188,7 @@
     if (hunt_server(cptr,sptr,":%s WHOWAS %s %s :%s", 3,parc,parv))
       return 0;
 
-  if(!IsAnOper(sptr) && !MyConnect(sptr)) /* pace non local requests */
+  if(!NoFloodProtection(sptr) && !MyConnect(sptr)) /* pace non local requests */
     {
       if((last_used + WHOIS_WAIT) > CurrentTime)
         {
@@ -224,7 +224,7 @@
                      parv[0],
                      temp->name,
 #ifdef SERVERHIDE
-                     IsAnOper(sptr) ? temp->servername : NETWORK_NAME,
+                     IsSetOperAuspex(sptr) ? temp->servername : NETWORK_NAME,
 #else
                      temp->servername,
 #endif
